babies <- read.table("babies.csv", header=T,sep=" ")
babies

##grfico peso do bebe por tempo de gestao
plot(bwt~gestation, data=babies)

##tirando observaes com dados faltantes
babies.0 <- babies[babies$gestation!=999,]
babies.0
##nmero de observaes
n <- length(babies.0$gestation)
n
plot(bwt~gestation, data=babies.0)

x <- seq(min(babies.0$gestation),max(babies.0$gestation),length.out=100 )
x
media.ob <- mean(babies.0$gestation)
media.ob
soma.dquad <- sum((babies.0$gestation-media.ob)^2)
soma.dquad

##varincia valores y
var.y <- var(babies.0$bwt)
var.y

##erro padro modelo
se.y <- sqrt(var.y*(1/n+((x-media.ob)^2)/soma.dquad))
se.y

##modelo peso~tempo gestao
mod.bab <- lm(babies.0$bwt~babies.0$gestation)
summary(mod.bab)
##coeficientes modelo
coef.bab <- coef(mod.bab)
coef.bab

##valores preditos de y
y <- coef.bab[1]+coef.bab[2]*x
y
##grau de liberdade
gl <- n-2
gl

quan.t <- qt(0.95,gl)
quan.t

##intervalos de confiana
int.conf1 <- y + (se.y*quan.t)
int.conf1
int.conf2 <- y - (se.y*quan.t)
int.conf2

##grfico com intervalo de confiana
plot(bwt~gestation, data=babies.0)
abline(mod.bab, col="red",lwd=2)
curve((coef.bab[1]+(coef.bab[2]*x))+(se.y*quan.t),add=T,col="blue",lwd=2,n=100)
curve((coef.bab[1]+(coef.bab[2]*x))-(se.y*quan.t),add=T,col="blue",lwd=2,n=100)
