########## Editando parmetros grficos #########

saligna<-read.table("esaligna.csv",sep=",",header=T)
plot(saligna$dap,saligna$ht, main="*Eucalypthus saligna*", cex.main=1.8, pch=16, col="red", cex=1.4, xlab="", ylab="", cex.axis=1.5, las=1, tck=0.03, bty="l")
mtext("Dimetro  altura do peito (cm)", side=1, line=3, cex=1.7)
mtext("Altura (m)", side=2, line=3, cex=1.7)
png(filename = "saligna.png")
graphics.off()

######### Dois grficos juntos ##########

par(mfrow=c(1,2), las=1, tck=0.03, bty="l")
boxplot(saligna$dap~saligna$talhao,main="*Eucalypthus saligna*",cex.main=1.6,cex.axis=1.3,xlab="Talhes",ylab="Dimetro  altura do peito (cm)",cex.lab=1.5)
text(x=1,y=23,labels="A")
mean.saligna<-tapply(saligna$dap, saligna$talhao,FUN=mean)
mean.saligna
sd.saligna<-tapply(saligna$dap,saligna$talhao,FUN=sd)
sd.saligna
mn<-round(mean.saligna, digits=0)
mn
sd<-round(sd.saligna, digits=0)
sd
dpA<-(mn-sd)
dpA
dpB<-(mn+sd)
dpB  
plot(mean.saligna,ylim=c(0,30),pch=16, col="red", cex=1.4, xaxt="n", main="*Eucalypthus saligna*", cex.main=1.6,cex.axis=1.3,xlab="Talhes", ylab="Mdia DAP",cex.lab=1.5)
segments(c(1,2,3,4,5,6),c(6,7,8,10,9,7),c(1,2,3,4,5,6),c(14,19,16,20,19,19))
text(x=1.5,y=30,labels="B")
axis(side=1, at=c(1,2,3,4,5,6), c(16,17,18,22,23,32)) 


######## Adivinhando o cdigo #########

ex<-read.table("exercicio3.csv",sep=",",header=T)
par(mfrow=c(1,2), tck=0.03, bty="l", family="serif", font=1, cex.lab=1.7,mgp=c(2,0.5,0))
plot(ex$x1,ex$y1,pch=17,ylim = c(0,3.0), xlim=c(0.5,2.2), ylab="Euclidean distances", xlab = "Log(Patch size)(ha)", cex.axis=1.4)
text(x=2.2,y=3.0,labels=c("a"),cex=1.7)
model1<-lm(ex$x1~ex$x2)
abline(model1, lwd=2)
boxplot(ex$x2~ex$y2, outline=FALSE, ylim = c(0,3.0), xaxt="n", cex.axis=1.4)
text(x=c(1,2,3,4,5,6),y=3.0,labels=c("*","*","**","*","***","b"),cex=1.7)
axis(side=1, at=c(1,2,3,4,5,6), labels=c("Small","Medium\nEdge","Medium\nInterior","Large\nEdge","Large\nInterior","Control"), mgp=c(2,2,0),cex.axis=1.1)