########## 7.2 O modelo mais simples possvel ##########



library(MASS)
data(Animals)
Animals

##regresso da massa do crebro em funo da massa corporal de mamferos

anim.m2 <- lm(log(brain)~log(body),data=Animals, 
              subset=!(log(Animals$body)>8&log(Animals$brain)<6))
summary(anim.m2)

##ajustando o modelo

anim.m0 <- update(anim.m2, .~. -log(body))
summary(anim.m0)

##comparando os modelos

anova(anim.m0,anim.m2)

##1.Qual a relao do comando 'anova' acima com: 

anova(anim.m2)

?anova

##O comando anova(anim.m0,anim.m2) compara os dois modelos, anim.m2 e anim.m0 (modelo nulo)
##para verificar a importncia da varivel de tamanho do corpo para explicar a variao no
##no tamanho do crebro. Como os modelos diferem entre si (p=3.243e-14), podemos assumir que
##o tamanho do corpo explica a variao no tamanho do crebro.
##J o comando anova (anim.m2) testa se cada termo do modelo  significante, por isso ao testar
##a varivel de tamanho corporal, seu valor de p  igual ao valor obtido quando comparamos com o 
##modelo nulo (modelo mais simples, sem a varivel tamanho corporal).
##

##2. Qual a relao entre os valores obtidos por estes comandos:

summary(anim.m0)
mean(log(Animals$brain[!(log(Animals$body)>8&log(Animals$brain)<6)]))
sd(log(Animals$brain[!(log(Animals$body)>8&log(Animals$brain)<6)]))

##Observando os valores de summary(anim.m0), vemos que o intercepto do modelo nulo 
##coincide com o valor da media de (log(Animals$brain[!(log(Animals$body)>8&log(Animals$brain)<6)]))
##e o valor dos resduos do modelo nulo coincide com o valor do desvio padro de 
##(log(Animals$brain[!(log(Animals$body)>8&log(Animals$brain)<6)])).
