
#----------------Uma estimativa da incerteza na previso do modelo--------------

babies=read.table("babies.txt",header=T,sep="", dec=".", as.is=T)
babies
str(babies)
summary(babies)
head(babies)
tail(babies)

#substituindo os valores por NA
babies$bwt[babies$bwt==999]=NA
babies$gestation[babies$gestation==999]=NA
babies$parity[babies$parity==9]=NA
babies$age[babies$age==99]=NA
babies$height[babies$height==99]=NA
babies$weight[babies$weight==999]=NA
babies$smoke[babies$smoke==9]=NA
babies=na.exclude(babies)
babies
head(babies)
tail(babies)


dev.off()
#criando o plano para o grafico com as caracteristicas que eu quero..
?par
par(mar=c(5,5,4,4),cex.lab=1.5, cex.axis=1, las=1,
    bg = "gray85", bty="l")

#criando o plot, mas ainda sem os pontos... por isso NA...)
#ann=legenda dos eixos
?plot

plot(NA, type="l", ann = FALSE,
     xlim =range(babies$gestation), ylim = range(babies$bwt))

#a linhas de baixo so opcionais...  s um detalhe do grfico. Preenchimento da
#da rea interna do plot com uma cor mais calra. Nada impede de ser um plot todo branco.

rect(par()$usr[1],par()$usr[3], par()$usr[2],par()$usr[4],
     col="gray99", border=) 


?plot
?rect
points(bwt ~ gestation, data = babies, pch = 19,cex= 1.5,
       col = rgb(0,0,1, 0.3))
?rect
?par

#nomeando os eixo/s

mtext("Gestao (dias)", 1,  line=3, cex = 1.7)
mtext("Massa corporal do beb (kg)", 2, line=3, cex = 1.7, las = 0)


#Aplicamos a funo a uma formula que descreve
#o peso do bebe pelos dias de gestao.

lmbabies=lm(bwt~gestation, data=babies)
summary(lmbabies)

#Criamos um novo data.fram que junta o valor dos dias da gestao.
#Criando um vetor para representar a varivel preditora como uma sequncia de 500 
#valores compreendidos entre os valores mximo e mnimo da varivel preditora observada.

new.x = seq(min(babies$gestation)-50, max(babies$gestation)+50, length.out=500)

#Agora ns aplicamos a funo preditora que define a varivel preditora
#no argumento newdata. Tambm definimos o tipo de intervalo como "confidence", 
#e usamos o default 0.95 nvel confiana.

preds = predict(lmbabies, newdata = data.frame(gestation=new.x), 
                 interval = 'confidence')

table(rbind(head(preds),tail(preds)))#no entendi essa linha...

#desenhando o intervalo de confiana no grfico

polygon(c(rev(new.x), new.x), c(rev(preds[ ,2]), preds[ ,1]),
        col = rgb(0,0,0,0.2), border = NA)#desenhando o plgono correspondete ao intervalo deconfianca

#col=rgb(verm,verde,azul,transparncia)

#aplicando a linha da regresso...
abline(lmbabies, lwd = 2, col = "black")


#acho que no ficou muito certo no...




# -------------------- Galileu estava Certo? ------------------------------

#As alturas de lanamentos e as distncias percorridas obtidas por Galileu 
#so2):

init.h = c(600, 700, 800, 950, 1100, 1300, 1500)
h.d = c(253, 337, 395, 451, 495, 534, 573)

#Vamos fazer o grfico de disperso:

plot(h.d~init.h)

#Mas para ajustar a parbola corretamente usamos a funo I() (de insulate), 
#necessria para isolar a operao matemtica de elevar ao quadrado. 
#Sem isto, o R entender o termo init.h^2 como uma interao, detalhes aqui, 
#na seo Uma Palavra sobre o Argumento Frmula.

#O comando para ajustar a equao da parbola :
#mais completo

(mod3 = update(mod2,.~.+I(init.h^3)))
summary(mod3)

(mod2 = update(mod1,.~. +I(init.h^2)))
summary(mod2)
anova(mod2,mod3)

(mod1 = lm(h.d~init.h))
summary(mod1)
anova(mod1,mod2)
anova(mod1,mod3)

#RESP:Sim, um polinmio de terceiro grau  um melhor modelo 
#para descrever os dados do experimento de Galileu. 
#A variao no explicada pelos dados   muito menor no polinmio de 
#terceiro grau (4) do que no de segundo (13,64) e consequentemente o 
#modelo do polinmio de terceiro grau, explica muito mais (F= 1595) 
#do que o de segundo grau (F=205). Alm disso, 99% (R2)da variao dos dados
# explicada pelo modelo.




# ---------------------------- Massa de Recm-Nascidos ---------------------


babies=read.table("babies.txt",header=T,sep="", dec=".", as.is=T)
babies
str(babies)
summary(babies)
head(babies)
tail(babies)

#substituindo os valores por NA
babies$bwt[babies$bwt==999]=NA
babies$gestation[babies$gestation==999]=NA
babies$parity[babies$parity==9]=NA
babies$age[babies$age==99]=NA
babies$height[babies$height==99]=NA
babies$weight[babies$weight==999]=NA
babies$smoke[babies$smoke==9]=NA
babies=na.exclude(babies)
babies
head(babies)
tail(babies)

#condstruindo o modelo cheio. I.e. com todas as variveis preditoras e as possveis 
#as interaes entre elas.

mod.cheio=lm(bwt ~ gestation + parity + age + height + weight + smoke
	+ gestation:parity + gestation:age
	+ gestation:height + gestation:weight + gestation:smoke
	+ parity:age + parity:height + parity:weight + parity:smoke
	+ age:height + age:weight + age:smoke
	+ height:weight + height:smoke + weight:smoke 
	+ gestation:parity:age + gestation:parity:height + gestation:parity:smoke
	+ parity:age:height + parity:age:weight + parity:age:smoke
	+ age:height:weight + age:height:smoke
	+ height:weight:smoke
	+ gestation:parity:age:height + gestation:parity:age:weight + gestation:parity:age:smoke
	+ parity:age:height:weight + parity:age:height:smoke
	+ age:height:weight:smoke
	+ gestation:parity:age:height:weight + gestation:parity:age:height:smoke
	+ parity:age:height:weight:smoke
	+ gestation:parity:age:height:weight:smoke,data=babies)

summary(mod.cheio)

#Das interaes usadas no modelo, somente a interao gestation:age, gestation:weight, gestation:smoke
#foram indicadas como com grande certeza de explicarem a varivel resposta (peso do bebe).



##### REMOO DE INTERAES NO SIGNIFICATIVAS 


#Assim, um novo modelo ser feito, considerando, das interaes, somente aquelas
# que o modelo apresentou grande probabilidade de influncia sobre a v. resposta.

mod.1=lm(bwt ~ gestation + parity + age + height + weight + smoke
	+ gestation:age + gestation:weight + gestation:smoke, data=babies)

summary(mod.1)	
#as variveis resposta e suas interaes explicam 27% das variaes dos dados e 
#o modelo explica quase 50 vezes a mais que o modelo nulo.
#ainda tem variveis preditoras que o modelo apresenta grande incerteza de influenia...

#removi a interao gestation:weight que no  mais significativa...

mod.2=lm(bwt ~ gestation + parity + age + height + weight + smoke
	+ gestation:age + gestation:smoke, data=babies)

summary(mod.2)


##### REMOO DA VARIVEL EXPLICATIVA NO SIGNIFICATIVA 


#vou remover gestao que no apresentou significncia sobre os dados

mod.3=lm(bwt ~ parity + age + weight + height + smoke 
	+ gestation:age + gestation:smoke, data=babies)

summary(mod.3)
#o modelo 2 explica melhor do que o modelo 1 (pelo valor de F)
#Peso mostrou-se agora com pouca ifluncia sobre os dados



#vou remover o peso que no apresentou significncia sobre os dados

mod.4=lm(bwt ~ parity + age + height + smoke 
	+ gestation:age + gestation:smoke, data=babies)

summary(mod.4)
#R2 = 27% da variao dos dados est sendo explicada pelas preditoras no modelo.
#F = o modelo agora explica 71 vezes mais que o modelo nulo...


##### COMPARANDO MODELOS 

#melhor modelo at ento,  o 4! mod.4

#sem smoke

mod.5=lm(bwt ~ age + height + parity 
	+ gestation:age + gestation:smoke, data=babies)

summary(mod.5) #o valor do F est grande....
anova(mod.5,mod.4)
#R2=25%
#F=81
#A retirada do smoke, fez com que o modelo explicasse 81 vezes 
#mais do que o modelo nulo e 17 vezes mais que o modelo 4, porm ele parece
#ser uma varivel preditora importante... Pela grande probabilidade de ser
#importante (valor de P)


#removendo parity

mod.6=lm(bwt ~ age + height + smoke 
	+ gestation:age + gestation:smoke, data=babies)

summary(mod.6)
anova(mod.4,mod.6)
#R2=26%
#F=83
#A retirada de parity fez com que o modelo explicasse 83 vezes 
#mais do que o modelo nulo.
#mas ainda  importante...


#removendo age

mod.7=lm(bwt ~ height + parity + smoke
	+ gestation:age + gestation:smoke, data=babies)

summary(mod.7)
anova(mod.4,mod.7)
# com a retirda da idade o novo modelo explica 58 a mais do que o modelo nulo.
#mais ainda  importante para explicar os dados


#removendo height

mod.8=lm(bwt ~ age + parity + smoke
	+ gestation:age + gestation:smoke, data=babies)

summary(mod.8)
anova(mod.4,mod.8)
#R2=23%
#F=72
#ainda  importante..


#removendo gestation:age

mod.9=lm(bwt ~ age + parity + smoke + height
	+ gestation:smoke, data=babies)

summary(mod.9)
anova(mod.4,mod.9)
#R2=19%
#F=57
#ainda  importante


#removendo gestation:smoke

mod.10=lm(bwt ~ parity + age + height + smoke
	+ gestation:age, data=babies)

summary(mod.10)
anova(mod.4,mod.10)
#R2=26%
#F=82

#RESP: O peso dos bebs parecem ser melhor explicados pela paridade (ou seja, pelo nmero 
#de vezes que a me j teve partos antes), idade e altura da me e se ela  fumante ou no. 
#Alm disso, pelas interaes entre os dias de gestao e idade e o fato de ser fumante ou no.
#R2 = 27% da variao dos dados est sendo explicada pelas preditoras do melhor modelo (na minha opinio).
#O modelo encontrado explica 71 vezes mais do que o modelo nulo.
