####Exerccio 4.2 - Cervejas

cervejas = c("chope","lata","garrafa","chope","garrafa", "garrafa","lata","lata","nenhuma","lata","garrafa","garrafa", "garrafa","lata","lata","lata","garrafa","lata","chope","nenhuma", "garrafa","garrafa","garrafa","chope","garrafa","garrafa","chope","garrafa","lata","lata")

# 1. Represente este resultado como um grfico de barras e um dotplot (funo dotchart).
# Primeiramente  necessrio agrupar as variveis de caracteres em outro formato.
# Fazemos isso com o comando
cervejas = table(cervejas)
#Construindo o histograma
barplot(cervejas)
#Construindo o dotplot
dotchart(cervejas)
# 2. Qual tem maior razo dado/tinta?
# O segundo (dotchart).

####Exerccio 4.3 - Caixetais

# 1. Construa um histograma do dap1) dos fustes dos caixetais.
#Primeiramente carregamos os dados
caixeta = read.csv("caixeta.csv", as.is=T)
#Verificando a estrutura do dataframe
str(caixeta)
#Criando a coluna dap
caixeta$dap = caixeta$cap/pi
#Criando o histograma
hist(caixeta$dap)
# 2. Construa histogramas da altura das rvores para os diferentes caixetais ('local').
#Transformar local em fator e construir o histograma
caixeta$local = as.factor(caixeta$local)
par(mfrow=c(3,1))
hist(caixeta$h[caixeta$local=="chauas"], breaks = 15, col="gray")
hist(caixeta$h[caixeta$local=="jureia"], breaks = 15, col="gray")
hist(caixeta$h[caixeta$local=="retiro"], breaks = 15, col="gray")
par(mfrow=c(1,1))
# 3. H diferenas entre as estruturas (distribuio de tamanhos) dos caixetais?
#Vamos criar um boxplot para ver melhor a estrutura dos diferentes locais.
plot(caixeta$h~caixeta$local)
#Com esses quatro grficos  podemos identificar melhor a distribuio de tamanhos dos diferentes caixetais.
#Chauas e Jureia apresentam distribuio bem similar, porm, as rvores so um pouco maiores em Jureia.
#Pelos histogramas, Retiro parece apresentar uma distribuio bimodal, com um pico em torno de 50 e outro em torno de 80. 
#Ademais, h um claro outlier prejudicando a interpretao do histograma de Chauas, a qual  melhor vista pelo boxplot.

####Exerccio 4.4 - Eucaliptos

#Lendo o arquivo e verificando a estrutura do objeto.
egr = read.table("egrandis.csv", sep=";", header=T, as.is=F)
str(egr)
# 1. Utilize o grfico boxplot para analisar o DAP de rvores de E. grandis em funo das variveis regio (regiao) e rotao (rotacao).
#Construindo o grfico de dap por regio.
plot(egr$dap~egr$regiao)
#Todas as localidades apresentam medianas similares. O intervalo entre Q1 e Q3  consideravelmente menor em Salto, onde parece haver uma maior mdia de DAP (desconsiderando outliers).
#Todas as regies possuem possveis outliers pelo mtodo default de definio de outliers da funo. Sendo isso mais notvel em Bofete. 
#Uma anlise mais cuidadosa provavelmente revalaria que grande parte desses valores no so outliers.
#Para construir o grfico de dap por rotao primeiro  necessrio transformar rotao em fator.
egr$rotacao = as.factor(egr$rotacao)
plot(egr$dap~egr$rotacao)
#rvores de rotao 1 aparentam ser consideravelmente maiores que s de rotao 2.
#Assim como na medida por regio, h tambm diversos outliers, especialmente para rvores de rotao 1.
# 2. Avalie a normalidade da altura do conjunto total de rvores com um grfico quantil-quantil contra a distribuio normal.
#Fazemos isso com a funo qqnorm() e qqline().
qqnorm(egr$ht)
qqline(egr$ht, col="red")
#Podemos observar que a altura do conjunto de dados no segue um padro normal de distribuio.
#A curva se distancia do padro normal nas caudas e tambm  assimtrica, demorando mais para cair no infinito-positivo.
#Fazendo um plot da densidade fica mais fcil observar a distribuio.
plot(density(egr$ht))
curve(expr = dnorm(x,mean=mean(egr$ht),sd=sd(egr$ht)),add=T, col="red")

####Exerccio 4.5 - Mais caixetais

# 1. Analise a relao dap-altura ('dap' e 'h') em funo do caixetal (local) com a funo plot, mas somente para as rvores 2) de caixeta (Tabebuia cassinoides).
#Primeiramente vamos separar do dataframe apenas as linhas referentes  Tabebuia cassinoides.
tcas = caixeta[caixeta$especie=="Tabebuia cassinoides",]
#Separando o dataframe por regies:
tcas1 = tcas[tcas$local=="chauas",]
tcas2 = tcas[tcas$local=="jureia",]
tcas3 = tcas[tcas$local=="retiro",]
#Construindo os grficos com plot:
par(mfrow=c(1,3))
plot(tcas1$dap~tcas1$h)
plot(tcas2$dap~tcas2$h)
plot(tcas3$dap~tcas3$h)
#Ambos os locais apresentam relaes similares, com aparente correlao entre dap e h, porm, em Chauas, h um outlier cuja altura  extremamente alta e dap extremamente baixa, provavelmente tratando-se de um erro na matriz de dados.
# 2. Para a mesma relao do item anterior, verifique linearidade com a funo scatter.smooth
par(mfrow=c(1,1))
scatter.smooth(tcas$dap, tcas$h, col="red")
#O conjunto total de dados aparenta ter uma distribuio que se aproxima da linear.
# 3. Utilizando o pacote lattice, analise a relao dap-altura ('dap' e 'h') em funo do caixetal (local), mas somente para as rvores 3) de caixeta (Tabebuia cassinoides).
library(lattice)
xyplot(dap~h|local , data = tcas)
#Em funo do outlier (mencionado acima), o grfico pela funo xyplot fica extremamente difcil de analisar para todas as localidades.
#Isso pois o outlier aumenta a escala x de todos os grficos e todos os pontos se concentram  esquerda.
#No caso acima (funo plot), apenas o grfico que possuia o outlier (Chauas) apresentava esse problema.
