##Uma estimativa da incerteza na previso do modelo

babi=read.table("babies.txt",sep="", dec = ".", header = T)
head(babi)

#Eliminando valores sem informao
babi$bwt[babi$dwt==999]=NA
babi$gestation[babi$gestation==999]=NA
bab=na.omit(babi)

#Convertendo valores de bwt a Kg
bab$bwt=bab$bwt/35.27

# Fazendo o modelo

m.bab=lm(bwt~gestation, data = bab)
summary(m.bab)

#calculando intervalo

vari=var(bab$bwt)
sdd=sum((bab$gestation-mean(bab$gestation))^2)
num=((bab$gestation-mean(bab$gestation))^2)
ab=1/length(bab$gestation)

inter=sqrt(vari*(ab+(num/sdd)))
result=summary(lm(bwt~gestation, data = bab))
result$coefficients
intervalo=inter*result$coefficients[2,3]
summary(m.bab)
coefi=coef(m.bab)
inclin=coefi[2]

valorsup=m.bab$fitted.values+intervalo
valorinf=m.bab$fitted.values-intervalo

#plotando intervalo

plot(bwt~gestation, data = bab, bty="l")
abline(m.bab, col="darkgreen")
lines(bab$gestation, valorinf, col="red")
lines(bab$gestation, valorsup, col="red")


##Galileu estava Certo?

init.h = c(600, 700, 800, 950, 1100, 1300, 1500)
h.d = c(253, 337, 395, 451, 495, 534, 573)
plot(h.d~init.h)
mod1 <- lm(h.d~init.h)
abline(mod1)
mod2 <- update(mod1,.~. +I(init.h^2))
anova(mod1,mod2)
abline(mod1)
cf.m2 <- coef(mod2)
curve(cf.m2[1]+cf.m2[2]*x+cf.m2[3]*x^2, add=T, lty=2, col="red")
mod3 <- update(mod1,.~. +I(init.h^2)+I(init.h^3))
anova(mod2, mod3)
cf.m3 <- coef(mod3)
curve(cf.m3[1]+cf.m3[2]*x+cf.m3[3]*x^2+cf.m3[4]*x^3, add=T, lty=2, col="darkgreen")
#Baseado na comparao de modelos e a curva ajustada no grfico, o modelo com um polinomio de tercer grau  o melhor modelo para explicar os dados de Galileu.