#7b. Exercícios de Regressão Múltipla
#Uma estimativa da incerteza na previsão do modelo
rm(list=ls())
setwd("~/Documents/mestrado/Disciplinas_2019/R_USP/8")
bebes <- read.table("babies.txt", header= TRUE, as.is = TRUE, sep= " ")

#Construa esse gráfico para avaliar a incerteza do modelo para a relação peso do bebê (kg) ~ tempo de gestação (dias) dos dados Massa ao Nascer e Dados da mãe, usando a fórmula acima para estimar o intervalo de confiança de 95%.

table(bebes$bwt)
table(bebes$gestation)
str(bebes)

summary(bebes)
summary(bebes$bwt)
summary(bebes$gestation)
plot(bwt~gestation, data=bebes)

bebes2 <- bebes[(bebes$bwt!=999 &               
                      bebes$gestation!=999 &
                      bebes$parity!=9 &
                      bebes$age!=99 &
                      bebes$height!=99 &
                      bebes$weight!=999 &
                      bebes$smoke!=9),]
head(bebes2)                                       
str(bebes2)                                        

plot(bwt~gestation, data=bebes2)

bebes2$pesokg <- bebes2$bwt*0.0283495            
head(bebes2)                                       
str(bebes2)                                        

lm.bebes2 <- lm(pesokg ~ gestation, data= bebes2) 
summary(lm.bebes2)                                  
plot(lm.bebes2)

sumx <- sum((bebes2$gestation - mean(bebes2$gestation))^2)
sumx                                                          

lim <- range(bebes2$gestation)                         
lim                                                      

pred <- seq( lim[1],lim[2], len=100);pred       
d.pred <- (pred - mean(bebes2$gestation))^2;d.pred           
                                               
n <- length(bebes2$gestation);n                             

s2 <- var(bebes2$pesokg) ;s2                                 

erro <- sqrt(s2*(1/n)+(d.pred/sumx));erro                       

tvalor <- qt(0.025, df=n-2) ;tvalor                                

int.conf <- erro * tvalor ;int.conf                               
coef.b <- coef(lm.bebes2);coef.b                                  
a <- coef.b[1];a                                              
b <- coef.b[2];b                                              
upper <- (a+b*c(pred)) + abs(int.conf);upper                    
lower <- (a+b*c(pred)) - abs(int.conf);lower                   

plot(lm.bebes2)

plot(NULL,
       mar=c(4,4,2,2),
       las=1,
       bty="n",
       pch="",
       col=rgb(0,0,1,0.5),
       ylab="Peso do bebê ao nascer (kg)",
       xlab="Duração da gestação (dias)",
       ylim=c(1,5),
       xlim=c(lim[1],lim[2]),           
       main="",
       sub="")

points(bebes2$pesokg ~ bebes2$gestation,
       pch=19,
       col=rgb(0,0,1, 0.4),
       cex=1.0)

abline(a= coef.b[1],
       b= coef.b[2],
       lwd= 3,
       col="red4")

polygon(c(rev(pred), pred),                    
        c(rev(upper), lower),                  
        col = rgb(1,0,0,0.2), 
        border = NA)


# -------------------------------------------------------------------------------------

#Galileu estava Certo?
  
#Partindo do tutorial Ajuste de Polinômios, avalie se um polinômio de terceiro grau é um melhor modelo para descrever os dados do experimento de Galileu. A equação para este modelo é:
  
# y= a + b * x + c * x^2 + d * x^3

init.h = c(600, 700, 800, 950, 1100, 1300, 1500)
h.d = c(253, 337, 395, 451, 495, 534, 573)

plot(h.d~init.h)

#Galileu tinha razões teóricas para supor que a relação seria uma parábola, e não uma reta, como propunha o conhecimento vigente. Hoje podemos tratar isto como um problema simples de seleção de modelos, em que os modelos concorrentes são uma equação da reta:

#   y= a + b*x

#e uma equação da parábola, que é um polinômio de segundo grau:
  
#  y = a+bx+c*x^2

#O primeiro modelo é um caso particular do segundo, no qual o coeficiente
#  c

#é zero. Portanto, podemos ajustar os dois modelos e usar o comando anova para testar se o acréscimo do termo quadrático implicou em melhora. O ajuste da reta é feito do modo usual:
mod1 <- lm(h.d~init.h)
mod2 <- update(mod1,.~. +I(init.h^2))
mod3 <- update(mod2,.~. +I(init.h^3))

anova(mod1,mod2,mod3)
anova(mod2,mod3)

abline(mod1)
cf.m2 <- coef(mod2)
curve(cf.m2[1] + cf.m2[2]*x + cf.m2[3]*x^2, add=T, lty=2, col="red")
cf.m3<- coef(mod3)
curve(cf.m3[1] + cf.m3[2]*x + cf.m3[3]*x^2 + cf.m3[4]*x^3, add=T, lty=6, col="blue")

# Resposta: O modelo terceiro (mod3) (polinomio de terceiro grau) é o melhor para explicar 

# ---------------------------------------------------------------------------------
#Massa de Recém-Nascidos

#Utilize todas as variáveis disponíveis no conjunto de dados Massa ao Nascer e Dados da mãe para chegar ao melhor modelo de previsão da massa de bebês ao nascer.
str(bebes)
#Parta do arquivo acima e não do que foi usado no tutorial. Antes de começar, elimine as observações com dados faltantes, veja descrição do arquivo.
ml.full<-lm(bwt~gestation*parity*age*smoke, data=bebes)
summary(ml.full)


## Interação Quadrupla (tira a interação quadrupla)
    #gestation:parity:age:smoke
ml.01 <- lm(bwt ~ gestation + parity + age + smoke + 
              gestation:parity + gestation:age + parity:age + gestation:smoke + parity:smoke + age:smoke+
              gestation:parity:age + gestation:parity:smoke + gestation:age:smoke + gestation:age:smoke + parity:age:smoke
            , data = bebes) 

summary(ml.01)
anova(ml.01, ml.full)


## Interação Tripla (tira as interações triplas)
    #parity:age:smoke 
ml.02 <- lm(bwt ~ gestation + parity + age + smoke + 
              gestation:parity + gestation:age + parity:age + gestation:smoke + parity:smoke + age:smoke+
              gestation:parity:age + gestation:parity:smoke + gestation:age:smoke + gestation:age:smoke
            , data = bebes) 

summary(ml.02)
anova(ml.02, ml.01)

    #gestation:age:smoke
ml.03 <- lm(bwt ~ gestation + parity + age + smoke + 
              gestation:parity + gestation:age + parity:age + gestation:smoke + parity:smoke + age:smoke+
              gestation:parity:age + gestation:parity:smoke + gestation:age:smoke + parity:age:smoke
            , data = bebes) 

summary(ml.03)
anova(ml.03, ml.01)
    
    #gestation:parity:smoke
ml.04 <- lm(bwt ~ gestation + parity + age + smoke + 
              gestation:parity + gestation:age + parity:age + gestation:smoke + parity:smoke + age:smoke+
              gestation:parity:age + gestation:age:smoke + gestation:age:smoke + parity:age:smoke
            , data = bebes) 

summary(ml.04)
anova(ml.04, ml.01)

    #gestation:parity:age 
ml.05 <- lm(bwt ~ gestation + parity + age + smoke + 
              gestation:parity + gestation:age + parity:age + gestation:smoke + parity:smoke + age:smoke+
              gestation:parity:smoke + gestation:age:smoke + gestation:age:smoke + parity:age:smoke
            , data = bebes) 

summary(ml.05)
anova(ml.05, ml.01)

    #melhor modelo de tripla




## Interações Dupla (tira e testa cada interação dupla)
    # age:smoke
ml.06 <- lm(bwt ~ gestation + parity + age + smoke + 
              gestation:parity + gestation:age + parity:age + gestation:smoke + parity:smoke
            , data = bebes) 

summary(ml.06)
anova(ml.06, ml.full)

    # parity:smoke
ml.07 <- lm(bwt ~ gestation + parity + age + smoke + 
              gestation:parity + gestation:age + parity:age + gestation:smoke
            , data = bebes) 

summary(ml.07)
anova(ml.07, ml.full)

    # gestation:smoke
ml.08 <- lm(bwt ~ gestation + parity + age + smoke + 
              gestation:parity + gestation:age + parity:age + parity:smoke
            , data = bebes) 

summary(ml.08)
anova(ml.08, ml.full)

    # parity:age
ml.09 <- lm(bwt ~ gestation + parity + age + smoke + 
              gestation:parity + gestation:age + gestation:smoke + parity:smoke
            , data = bebes) 

summary(ml.09)
anova(ml.09, ml.full)

    # gestation:age
ml.10 <- lm(bwt ~ gestation + parity + age + smoke + 
              gestation:parity + parity:age + gestation:smoke + parity:smoke
            , data = bebes) 

summary(ml.10)
anova(ml.10, ml.full)

    # gestation:parity 
ml.11 <- lm(bwt ~ gestation + parity + age + smoke + 
             gestation:age + parity:age + gestation:smoke + parity:smoke
            , data = bebes) 

summary(ml.11)
anova(ml.11, ml.full)


AIC(ml.full, ml.01, ml.02, ml.03, ml.04, ml.05, ml.06, ml.07, ml.08, ml.09, ml.10, ml.11)
anova(ml.full, ml.01, ml.02, ml.03, ml.04, ml.05, ml.06, ml.07, ml.08, ml.09, ml.10, ml.11)

