#Exercício 1.

#Os palmitos estão distribuídos aleatoriamente na floresta? Durante a aula teórica mostramos como podemos usar uma distribuição teórica para gerar dados que simulem o cenário previsto por nossa hipótese nula. No caso da posição dos palmitos adultos em uma parcela de 10,24 ha de floresta (320×320 m), nossa hipótese nula é que eles se distribuem aleatoriamente no espaço. Iniciamos a construção do código para testar essa hipótese, o exercício é terminar de testar a hipótese. Abaixo reproduzimos o código apresentado em aula para que possa continuar a partir dele.

#1.1. Baixe o arquivo palmadulto.txt e leia os dados no R em um objeto chamado eutad, não esqueça de conferir se o objeto de dados foi lido corretamente.
eutad<-read.table("palmadulto.txt", header =T, sep = "\t", as.is=T)
str(eutad)

#1.2. Crie o objeto para guardar as distâncias entre cada indivíduo:
dist=matrix(NA, ncol=102, nrow=102)

#1.3. Calcule a distãncia observada entre cada indivíduo e guarde o results em dist:
    for(i in 1:101)
  {
    for(j in (i+1):102)
    {
      difx2=(eutad$gx[i]-eutad$gx[j])^2
      dify2=(eutad$gy[i]-eutad$gy[j])^2
      dist[i,j]<-sqrt(difx2 + dify2)
      dist[j,i]<-sqrt(difx2 + dify2)
    }
    
  }

  #1.4. Verifique o objeto dist e calcule o parâmetro chamado de distância média do vizinho mais próximo (MNN):
(nn<-apply(dist, 1, min, na.rm=TRUE))
(mnn<-mean(nn))

#Simulando

result<-rep(NA, 1000)
result[1]<-mnn
result[1:5]
for(k in 2:1000){
  xsim<-round(runif(102, 0, 320), 1)
  ysim<-round(runif(102,0,320),1)
  rxy<-data.frame(xsim, ysim)
  rdistmat<-as.matrix(dist(rxy, diag=F, upper=T))
  diag(rdistmat)<-NA    
  rnnd<-apply(rdistmat, 1, min, na.rm=T)
  result[k]<-mean(rnnd)
}

result
hist(result)
abline(v=result[1], lty=2, col="red")


result1<-result-mean(result)
hist(result1)
abline(v=result1[1], lty=2, col="red")

nmaior<-sum(abs(result1)>=abs(result1[1]))
pvalor<-nmaior/length(result1)

#Com o pvalo de 0.049, evidencia que a distância calculada não foi gerada pelo acaso.


#-----------------------------------------------------------------------------
#2 Exercicio.
#Simulando o teste de uma regressão linear

#O principal teste estatístico de uma regressão linear é que a inclinação do modelo da reta é diferente de zero! Isso significa que a variável preditora é independente da variável reposta. Ou seja não há relação aparente entre elas. Utilizando os dados de massa corpórea e do cérebro de alguns vertebrados Conjunto de Dados: Massa do Corpo e do Cérebro de Vertebrados:
  
anim<-read.table("animais.txt", header=T, sep=";", as.is=T, dec = ",")
str(anim)
anim$body<-as.numeric(anim$body)
anim$brain<-as.numeric(anim$brain);anim

str(anim)
anim<-na.exclude(anim)
plot(brain~body, data=anim, log="xy") 
lm.massa <- lm(log(brain)~log(body),data=anim)
summary(lm.massa)
abline(lm.massa)                                                        

coef.massa<-coef(lm.massa)

result.sim<-rep(NA, 1000)
result.sim[1]<-coef.massa[2]
result.sim[1:5]
cerebro<-anim$brain

for(i in 2:1000){
  sim_brain<-sample(cerebro)
  result.sim[i]<-coef(lm(log(sim_brain)~log(body), data=anim))[[2]]
}
result.sim
hist(result.sim)
abline(v=result.sim[1], lty=2, col="red")

pvalor<-sum(abs(result.sim)>=abs(result.sim[1]))/length(result.sim)


#Resposta: Com o p=0.002 (p<0.05), as variáveis são dependentes e também existe uma correlação positiva significativa entre elas.