#9.2 Exercício Análise exploratória simultânea de duas variáveis

#Tarefa: Crie uma função para saída gráfica de análises exploratórias de duas variáveis. Essa saída pode ter por exemplo boxplot, histograma, qq norm e y por x. A função deve permitir a entrada de dois objetos vetores de mesmo tamanho (x e y). Caso os valores de x e y forem desenhados em um mesmo gráfico, defina cores diferentes. As legendas devem ser em português e a saída (return) deve apresentar o sumário das duas variáveis e o coeficiente de correlação.

#DICAS:
  
#Para histogramas com variáveis em um mesmo gráfico pode ser utilizada a função multhist() do pacote “plotrix”. Baixe, instale o pacote e veja o help da função.

#Utilize o código do eda.shape, apresentado em aula como ponto de partida.

#Lembre-se que em algumas funções gráficas o argumento add=TRUE, adiciona elementos no gráfico anterior.

graphic<-function(x,y)
{
  if(class(x)!="numeric"|class(y)!="numeric")
    {stop("A variável não é numérica")}
  if(length(x)!=length(y))
    {stop("Os vetores são de tamanhos diferentes")}
  par(mfrow=c(2,2), mar=c(4,4,2,2))
  plot(y~x, xlab="Variável x", ylab="Variável y")
  boxplot(x,y)
  z<-list(x, y)
  multhist(z, col=c("blue", "red"))
  cor<-cor(x,y, method="pearson")
  qqnorm(y)
  qqline(y, col="red")
  s<-list(summary(x), summary(y), cor)
  names(s) = c("x", "y", "Coeficiente de correlação de Pearson")
  return(s)
}  

x<-abs(rnorm(100, 20, 4))
y<-abs(rnorm(100, 10, 2))

graphic(x,y)
