#4.2 Cervejas

#### Uma amostra de 30 estudantes foi indagada sobre seu tipo de cerveja preferida, com o seguinte resultado

cervejas <-c("chope","lata","garrafa","chope","garrafa", "garrafa","lata","lata","nenhuma","lata","garrafa","garrafa", "garrafa","lata","lata","lata","garrafa","lata","chope","nenhuma", "garrafa","garrafa","garrafa","chope","garrafa","garrafa","chope","garrafa","lata","lata")

#### Represente este resultado como um gráfico de barras e um dotplot (função dotchart).
table(cervejas)
barplot(sort(table(cervejas), decreasing=T))

dotchart(table(cervejas))

#### Qual tem maior razão dado/tinta?
# O que ira usar maior quantidade de tinta é o barplot

#---------------------------------------------------------------

#4.3 Caixetais

#### Neste exercício, use o objeto caixeta, criado no tutorial Exploração de uma Variável Categórica.
caixeta<-read.csv("caixeta.csv", header =T, sep =',')

head(caixeta)

#### Construa um histograma do dap dos fustes dos caixetais.
hist(caixeta$cap [caixeta$fuste])

#### Construa histogramas da altura das árvores para os diferentes caixetais ('local').
par(mfrow=c(3,1))

hist( caixeta$h[ caixeta$local == "chauas" ] )
hist( caixeta$h[ caixeta$local == "jureia" ] )
hist( caixeta$h[ caixeta$local == "retiro" ] )

#### Há diferenças entre as estruturas (distribuição de tamanhos) dos caixetais?
#Sim, as escalas no eixo x e y são diferentes entre os 3 histogramas.

#No local Chauas, a frequencia das alturas das árvores estão mais concentradas entre 50 e 100m, mas no geral, está entre 0 e 200m.

#No local Jureia, a frequencia das alturas das árvores está melhor distribuido no histograma, possuindo uma distribuição mais ampla, com sua maior frequencia em torno de 100m e diminuindo gradativamente para menos e  para mais

#No local Retiro, a distribuição enão está uniforme, possuindo diferentes alturas com diferentes frequências.

#---------------------------------------------------------------

#4.4 Eucaliptos

#Neste exercício, use o conjunto de dados Inventário em Florestas Plantadas de Eucalyptus grandis.
e<-read.csv("egrandis.csv", header=T, sep=';')

#Utilize o gráfico boxplot para analisar o DAP de árvores de E. grandis em função das variáveis região (regiao) e rotação (rotacao).
boxplot(e$dap ~e$regiao*e$rotacao)

#Avalie a normalidade da altura do conjunto total de árvores com um gráfico quantil-quantil contra a distribuição normal.
qqnorm(caixeta$arvore)
qqline(caixeta$arvore, col="red", cex=2)

#-------------------------------------------------------------
#4.5 Mais Caixetais

# Aqui usaremos novamente o objeto caixeta, criado no tutorial Exploração de uma Variável Categórica.

#1. Analise a relação dap-altura ('dap' e 'h') em função do caixetal (local) com a função plot, mas somente para as árvores de caixeta (Tabebuia cassinoides).
cai<-caixeta[caixeta$especie == "Tabebuia cassinoides" ,]
cai$dap<-cai$cap/pi

par(mfrow=c(3,1))
plot(dap~h, data=cai, subset=local=="chauas", main = "Chauas")
plot(dap~h, data=cai, subset=local=="jureia", main="Jureia")
plot(dap~h, data=cai, subset=local=="retiro", main= "Retiro")


#2. Para a mesma relação do item anterior, verifique linearidade com a função scatter.smooth
par(mfrow=c(3,1))
scatter.smooth(cai$dap [cai$local== "chauas"] ~ cai$h[cai$local == "chauas"], main= "Chauas")
scatter.smooth(cai$dap [cai$local== "jureia"] ~ cai$h[cai$local == "jureia"], main= "Jureia")
scatter.smooth(cai$dap [cai$local== "retiro"] ~ cai$h[cai$local == "retiro"], main= "Retiro")

#3. Utilizando o pacote lattice, analise a relação dap-altura ('dap' e 'h') em função do caixetal (local), mas somente para as árvores 3) de caixeta (Tabebuia cassinoides).
xyplot(h~dap|local, data= cai)

#Dicas
#Veja o argumento subsets das funções de gráficos, a função subset e função with
#Para calcular o DAP de árvores de múltiplos fustes primeiro calcule as áreas basais de cada fuste, e então some-as. Em seguida, deduza desta área basal total o dap total.