# Aula 5 # Grficos

# exerccio 5.2

# lendo o conjunto de dados
saligna <- read.table("esaligna.csv", header = T, sep = ",", as.is = F)
head(saligna)


# checando o nmero de categorias do talhao
categoria.talhao <- table(saligna$talhao)

# calculando o valor mdio do DAP para cada talhao
media.talhao <- tapply(saligna$dap, saligna$talhao, mean)

# criando uma matriz de coordenadas do valor da mdia para poder usar na funo arrow que 
# permite criar a barra de desvio padrao no barplot
matriz.med <- matrix(media.talhao, nrow = 1, ncol = 6)

# calculando o desvio padrao do DAP para cada talhao
dp.talhao <- tapply(saligna$dap, saligna$talhao, sd)

# criando uma matriz de coordenadas do valor da mdia para poder usar na funo arrow que 
# permite criar a barra de desvio padrao no barplot
matriz.dp <- matrix(dp.talhao, nrow = 1, ncol = 6)

# gerando um plot de barras para ter o valor central da coordenada da matriz, i.e. a propria media 
barras <- barplot(media.talhao, beside = T, width = categoria.talhao)

graphics.off()

# plotando dois graficos um ao lado do outro (funcao mfrow)

par(mfrow=c(1,2))
# digo o tipo do primeiro grafico
par(cex = 1.4, las =1, tcl=0.3, bty="l")
boxplot(saligna$dap ~ saligna$talhao)
# editando 
# eixo y 
mtext("Dimetro  altura do peito (cm)", side=2, cex=1, las=3, line=2.5)
# eixo x
mtext("Talho", side=1, cex=1, line=2.5)
text(x= 1, y = 23, labels = "a")
# e do segundo

barplot(media.talhao, beside = T, width = categoria.talhao, ylim = c(0,25))
                  arrows(x0 = barras, x1 = barras, y0 = matriz.med - matriz.dp,
       y1 = matriz.med + matriz.dp, code=3, angle=90, length=0.1)
# editando 
# eixo y 
mtext("Media DAP (cm)", side=2, cex=1, las=3, line=2.5)
# eixo x
mtext("Talho", side=1, cex=1, line=2.5) 
text(3, 23, labels = "b")


                  

