# Aula 7.b 

# Exerccio 7.1

baby <- read.table("babies.txt", header = T, sep = " ", dec = ".")
head(baby)
str(baby)
summary(baby)

# Nesse conjunto de dados, para as duas colunas de interesse o valor 999 = ignorado ou NA
# Verifico se h esse valor nas minhas colunas de interesse e os retiro do dataframe. Um novo dataframe ser atribudo a um novo objeto.
which(baby$gestation == 999)
which(baby$bwt == 999)

bb <- baby[baby$gestation != 999,] 

# conferindo se est tudo ok:
which(bb$gestation == 999)
str(bb)

# fazendo o modelo
# PS: tentei indexar aqui e o R no estava aceitando, precisei colocar o nome da coluna e do conj. de dados 
mod.bebe <- lm(bwt ~ gestation, data = bb) 
summary(mod.bebe)

# criando um vetor com 100 valores da var. preditora
n.x <- seq(min(bb$gestation) - 30, max(bb$gestation) + 30, length.out = 100)

# obtendo os valores preditos pelo modelo para esse novo valor da v. preditora (n.x)
predito <- predict(mod.bebe, newdata = data.frame(gestation=n.x))

# calculando o erro padro para estimar o intervalo de confiana
ssx <- sum((n.x - mean(n.x))^2)
s2 <- var(bb$bwt)
n <- length(bb$bwt)
x <- n.x
x.m <- mean(n.x)

se <- sqrt(s2*(1/n + ((x-x.m)^2)/ssx))

# achando o valor de t de student (lembrando que so duas caudas, logo p = 0,025)
# quando quero achar o valor de t, usar a funo do quantil
t <- qt(0.025, length(bb$bwt)-2)

valores <- se * t 


ic.lwr <- predito - valores
ic.up <- predito + valores

# fazendo o grfico

par(mar=c(4,4,2,2),   cex.lab=1.5, cex.axis=1.2, las=1, bg = "gray70", bty="n")
plot(NA, type="n", axes = FALSE, ann = FALSE, xlim =range(bb$gestation), ylim = range(bb$bwt)) 
rect(par()$usr[1],par()$usr[3], par()$usr[2],par()$usr[4] , col="gray90")
points(bwt ~ gestation, data = bb, pch = 19,cex= 1.5, col = rgb(0,0,1, 0.4))
axis(1)
axis(2)
mtext("Tempo de gestao (dias)", 1,  line=2.5, cex = 1.7)
mtext("Peso do beb (kg)", 2, line=2.5, cex = 1.7, las = 0)

polygon(x = c(rev(n.x), n.x), y = c(rev(ic.up), ic.lwr),
        col = rgb(0,0,0,0.2), border = NA)

abline(mod.bebe, lwd = 2.5, col = "black")

# Aula 7.b

# exerccio 7.2

init.h = c(600, 700, 800, 950, 1100, 1300, 1500)
h.d = c(253, 337, 395, 451, 495, 534, 573)

plot(h.d~init.h)

# modelo1: equao da reta (relao linear)
mod1 <- lm(h.d~init.h)
summary(mod1)

# modelo2: parbola, com polinmio de segundo grau
mod2 <- update(mod1,.~. +I(init.h^2))
summary(mod2)

# modelo3: parbola, com polinmio de terceiro grau
mod3 <- update(mod1,.~. +I(init.h^2) +I(init.h^3))
summary(mod3)

# Dentre os modelos, o modelo 3 teve maior valor de F, valor de p muito baixo,
# R quadrado alto e menor erro padro dos resduos, portanto, foi o que mais explicou.

anova(mod2,mod3)
anova(mod1,mod2)
anova(mod1,mod3)

# Aula 7b

# exerccio 7.3

baby <- read.table("babies.txt", header = T, sep = " ", dec = ".")
head(baby)
str(baby)
summary(baby)

mod.full <- lm( bwt ~ gestation + age + height + weight + smoke + gestation:age + age:weight + height:weight + 
                  age:smoke + age:weight + weight:smoke, data = baby)

summary(mod.full)

# Opto por retirar primeiro a interao age:weight por causa do alto valor de p dessa interao

mod1 <- lm( bwt ~ gestation + age + height + weight + smoke + gestation:age + age:weight + height:weight + 
              age:smoke + weight:smoke, data = baby)

summary(mod1)

# comparando os modelos

anova(mod.full, mod1)

# posso ficar com o modelo mais simples porque no h diferena entre os modelos
# retiro a interao idade:peso no prximo (alto valor de p)

mod2 <- lm( bwt ~ gestation + age + height + weight + smoke + gestation:age + height:weight + 
              age:smoke + weight:smoke, data = baby)

summary(mod2)

anova(mod1, mod2)

# resultado da anova idem ao anterior. A prxima interao a ser retirada  peso:fumante

mod3 <- lm( bwt ~ gestation + age + height + weight + smoke + gestation:age + height:weight + 
              age:smoke, data = baby)
summary(mod3)

anova(mod2, mod3)

# p valor no significativo, retenho o modelo mais simples (i.e. mod3).
# irei retirar a interao entre o nmero de dias de gestao e a idade por causa do alto valor de p.

mod4 <- lm( bwt ~ gestation + age + height + weight + smoke + height:weight + 
              age:smoke, data = baby)

summary(mod4)

anova(mod3, mod4)

# novamente  valor de p foi no significativo e retenho o mais simples (mod4)
# irei retirar a interao idade:fumante

mod5 <- lm( bwt ~ gestation + age + height + weight + smoke + height:weight,  data = baby)

summary(mod5)

anova(mod4,mod5)

# o valor de p foi significativo, mantenho o modelo mais complexo, que nesse caso  mod4.
# Irei retirar a ltima interao, que  altura:peso.

mod6 <- lm( bwt ~ gestation + age + height + weight + smoke + age:smoke, data = baby)

summary(mod6)

anova(mod4,mod6)

# o valor de foi significativo, logo devo manter essa interao.
# irei retirar a varivel nmero de dias de gestao porque no participa de nenhuma intero.

mod7 <- lm( bwt ~ age + height + weight + smoke + height:weight + 
              age:smoke, data = baby)

summary(mod7)

anova(mod4,mod7)

# valor de p significativo. No posso retirar essa varivel. Irei retirar a varivel idade.

mod8 <- lm( bwt ~ gestation + height + weight + smoke + height:weight + 
              age:smoke, data = baby)

summary(mod8)            

anova(mod4,mod8)

# o valor de p no foi significativo, ento, posso retirar a varivel idade. Embora ela faa parte de uma interao que influencia a varivel resposta,
# biologicamente seria possvel que somente a idade da gestante no afetasse tanto o peso do beb como poderia afetar se a gestante for fumante.
# irei retirar a altura

mod9 <- lm( bwt ~ gestation + weight + smoke + height:weight + age:smoke, data = baby) 

summary(mod9)

anova(mod8, mod9)

# o valor de p foi significativo, ento fico com o modelo mais complexo (mod8). Irei retirar a varivel fumante

mod10 <- lm( bwt ~ gestation + height + weight + height:weight + age:smoke, data = baby)

summary(mod10)

anova(mod8,mod10)

# valor de p significatico, preciso manter o mod8. Irei retirar a ltima preditora, peso.

mod11 <- lm( bwt ~ gestation + height + smoke + height:weight + age:smoke, data = baby)

summary(mod11)

anova(mod8,mod11)

# o valor de p foi significativo, logo fico com o modelo complexo (mod8). Portanto, o modelo mnimo adequado :

mod8 <- lm( bwt ~ gestation + height + weight + smoke + height:weight + 
              age:smoke, data = baby)