### exercicios 7b ###


bebes <- read.table("babies.txt", sep="", h=T, as.is=T)
str(bebes)
#tirar observações com "999" em bwt,gestation e weight; "99" em age e height; 9 em parity e smoke
bebes <- bebes[bebes$gestation != 999, ]
bebes <- bebes[bebes$bwt != 999, ]
bebes <- bebes[bebes$weight != 999, ]
bebes <- bebes[bebes$age != 99, ]
bebes <- bebes[bebes$height != 99, ]
bebes <- bebes[bebes$parity != 9, ]
bebes <- bebes[bebes$smoke != 9, ] # nao consegui colocar em uma linha so de codigo com or (|)

#arrumando variaveis categoricas em fatores
bebes$smoke <- as.factor(bebes$smoke)
bebes$parity <-as.factor(bebes$parity)


## estimativa de incerteza do modelo
mod1 <- lm(bwt ~ gestation, data=bebes) # gerando modelo
summary(mod1) 

x.pred <- seq(from=min(bebes$gestation), to=max(bebes$gestation), length=100) #criando valores de x preditos

y <- coef(mod1)[1] + x.pred*coef(mod1)[2] #y dados pelo modelo
s2 <- var(bebes$bwt)#variancia de y
n <- 1/length(bebes$bwt)
dif.x <- (x.pred - mean(bebes$gestation))^2
SSX <- sum((bebes$gestation - mean(bebes$gestation))^2)

sey <- sqrt(s2*(n+(dif.x/SSX))) #calculo do erro padrao de cada ponto x predito

sey.t.neg <- y - (sey * qt(0.975, (length(bebes$bwt)-2))) #limites negativos de y
sey.t.pos <- y + (sey * qt(0.975, (length(bebes$bwt)-2))) #limites positivos de y

par(mar=c(4,4,2,2), cex.lab=1.2, cex.axis=1.2, las=1, bty="n")
plot(bwt ~ gestation, data=bebes, xlim=c(140,353), cex=0.8) #plotando dados observados
abline(mod1, col="red", lwd=3) #linha do modelo
lines(x=x.pred, y=sey.t.pos, col="blue", lty=2, lwd=2) #linha de limite positivo
lines(x=x.pred, y=sey.t.neg, col="blue", lty=2, lwd=2) #linha de limite negativo


## massa de recem nascidos
modFull <- lm(bwt ~ gestation*parity*age*height*weight*smoke, data =bebes)
summary(modFull)
anova(modFull) #observa-se significancia apenas a partir de interações duplas
mod01 <- lm(bwt ~ gestation + parity + age + height + weight + smoke + gestation:parity + gestation:age + gestation:weight + gestation:smoke + parity:age + parity:weight + parity:smoke + age:weight + age:smoke + height:weight + weight:smoke, data=bebes) #modelo sem interações triplas e duplas sem sentido biologico (interações de altura da mãe - height-com outras variáveis que nao sejam seu peso - weight)
anova(modFull,mod01) #começamos a simplificar a partir de interações duplas.

#simplificando o modelo
# interações duplas
# weight:smoke
mod02 <- lm(bwt ~ gestation + parity + age + height + weight + smoke + gestation:parity + gestation:age + gestation:weight + gestation:smoke + parity:age + parity:weight + parity:smoke + age:weight + age:smoke + height:weight, data=bebes)
anova(mod01,mod02) #interação nao tem significancia
# height:weight
mod03 <- lm(bwt ~ gestation + parity + age + height + weight + smoke + gestation:parity + gestation:age + gestation:weight + gestation:smoke + parity:age + parity:weight + parity:smoke + age:weight + age:smoke + weight:smoke, data=bebes)
anova(mod01,mod03) #interação nao tem significancia
# age:smoke
mod04 <- lm(bwt ~ gestation + parity + age + height + weight + smoke + gestation:parity + gestation:age + gestation:weight + gestation:smoke + parity:age + parity:weight + parity:smoke + age:weight + height:weight + weight:smoke, data=bebes)
anova(mod01,mod04) #interação nao tem significancia
# age:weight
mod05 <- lm(bwt ~ gestation + parity + age + height + weight + smoke + gestation:parity + gestation:age + gestation:weight + gestation:smoke + parity:age + parity:weight + parity:smoke + age:smoke + height:weight + weight:smoke, data=bebes)
anova(mod01,mod05) #interação nao tem significancia
# parity:smoke
mod06 <- lm(bwt ~ gestation + parity + age + height + weight + smoke + gestation:parity + gestation:age + gestation:weight + gestation:smoke + parity:age + parity:weight + age:weight + age:smoke + height:weight + weight:smoke, data=bebes)
anova(mod01,mod06) #interação nao tem significancia
# parity:weight
mod07 <- lm(bwt ~ gestation + parity + age + height + weight + smoke + gestation:parity + gestation:age + gestation:weight + gestation:smoke + parity:age + parity:smoke + age:weight + age:smoke + height:weight + weight:smoke, data=bebes)
anova(mod01,mod07) #interação nao tem significancia
# parity:age
mod08 <- lm(bwt ~ gestation + parity + age + height + weight + smoke + gestation:parity + gestation:age + gestation:weight + gestation:smoke + parity:weight + parity:smoke + age:weight + age:smoke + height:weight + weight:smoke, data=bebes)
anova(mod01,mod08) #interação nao tem significancia
# gestation:smoke
mod09 <- lm(bwt ~ gestation + parity + age + height + weight + smoke + gestation:parity + gestation:age + gestation:weight + parity:age + parity:weight + parity:smoke + age:weight + age:smoke + height:weight + weight:smoke, data=bebes)
anova(mod01,mod09) #interação TEM SIGNIFICANCIA!
# gestation:weight
mod10 <- lm(bwt ~ gestation + parity + age + height + weight + smoke + gestation:parity + gestation:age + gestation:smoke + parity:age + parity:weight + parity:smoke + age:weight + age:smoke + height:weight + weight:smoke, data=bebes)
anova(mod01,mod10) #interação nao tem significancia
# gestation:age
mod11 <- lm(bwt ~ gestation + parity + age + height + weight + smoke + gestation:parity + gestation:weight + gestation:smoke + parity:age + parity:weight + parity:smoke + age:weight + age:smoke + height:weight + weight:smoke, data=bebes)
anova(mod01,mod11) #interação TEM SIGNIFICANCIA
# gestation:parity
mod12 <- lm(bwt ~ gestation + parity + age + height + weight + smoke + gestation:age + gestation:weight + gestation:smoke + parity:age + parity:weight + parity:smoke + age:weight + age:smoke + height:weight + weight:smoke, data=bebes)
anova(mod01,mod12) #interação nao tem significancia

#criando modelo com as duas interações duplas de significancia e comparando-o com o modelo 01
mod13 <- lm(bwt ~ gestation + parity + age + height + weight + smoke + gestation:smoke + gestation:age, data=bebes)
anova(mod01,mod13) #interações duplas retiradas não tem significancia mesmo, por enquanto ficamos com o modelo 13

#comparando modelo 13 com modelo sem uma das duas interações
# gestation:age
mod14 <- lm(bwt ~ gestation + parity + age + height + weight + smoke + gestation:smoke, data=bebes)
anova(mod13,mod14) #interação continua significativa
# gestation:smoke
mod15 <- lm(bwt ~ gestation + parity + age + height + weight + smoke + gestation:age, data=bebes)
anova(mod13,mod15) #interação continua significativa

#para confirmar, vamos comparar o modelo corrente (13) com um modelo sem interações entre as variáveis
mod16 <- lm(bwt ~ gestation + parity + age + height + weight + smoke, data=bebes)
anova(mod13,mod16) #interações SÃO SIGNIFICATIVAS, permanecemos com o modelo 13 como modelo mínimo adequado

#finalmente, comparando o modelo mínimo adequado com o modelo nulo
anova(mod13)
# a variável "age" sozinha parece não tem significância, no entanto, uma vez que a interação "gestation:age"é significativa, não tem sentido em retirar tal variável do modelo
summary(mod13)



## galileu estava certo?
init.h <- c(600, 700, 800, 950, 1100, 1300, 1500)
h.d = c(253, 337, 395, 451, 495, 534, 573)

#criando modelos (mais complexo ao mais simples)
mod3 <- lm(h.d ~ init.h + I(init.h^2) + I(init.h^3))
mod2 <- lm(h.d ~ init.h + I(init.h^2))
mod1 <- lm(h.d ~ init.h)

anova(mod2,mod1)#modelo 2 e melhor, mostra que o parametro ao quadrado é significativo
anova(mod3,mod2) #modelo 3 é melhor em relação ao modelo 2, mostrando que o parametro ao cubo também é significativo

par(mar=c(4,4,2,2), cex.lab=1.2, cex.axis=1.2, las=1, bty="n")
plot(h.d ~ init.h, pch=16)
abline(mod1, col="red", lty=3)
curve(coef(mod2)[1] + coef(mod2)[2]*x+ coef(mod2)[3]*x^2, col="blue", lty=2, add=T, lwd=1.5 )
curve(coef(mod3)[1] + coef(mod3)[2]*x+ coef(mod3)[3]*x^2 + coef(mod3)[4]*x^3, col="green", add=T, lwd=2)
