##### EXERCICIOS 5 ######

### 5.1 ###
saligna <- read.table("esaligna.csv", h=T, sep=",") #lendo os dados
png("saligna.png") #abrindo dispositivo png para salvar o grafico
plot(saligna$ht ~ saligna$dap, #plotando altura por dap
     xlab="Diametro a altura do peito (cm)", #nome do eixo x
     ylab="Altura (m)",  #nome do eixo y
     pch=16, col="red", cex=1.4, #especificacao dos pontos
     cex.lab=1.7, cex.main=1.8, cex.axis=1.5, #especificacao do tamanho de legendas, eixos e titulo
     bty="l", tcl=0.3, las=1, main="*Eucalypthus saligna*") #especificacao de borda, tick marks e legenda dos eixos
dev.off() #fechando dispositivo

### 5.2 ###
saligna$talhao <- as.factor(saligna$talhao) #transformando talhao em variavel categorica de fatores
medias <- aggregate(saligna$dap, list(saligna$talhao), mean) #criando objeto com medias de dap por talhao
desvpad <- aggregate(saligna$dap, list(saligna$talhao), sd) #criando objeto com desvio padrao de dap por talhao

par(mfrow=c(1,2)) #layout de 2 graficos em 1 linha
par(bty="l") #especificacao de bordas
par(cex.axis=1.5) #especificacao de tamanho de fontes
par(cex.lab=1.7) #especificacao de tamanho de legenda
par(tcl=0.3) #tick marks internos ao grafico
par(las=1) #legenda dos eixos na horizontal

boxplot(saligna$dap ~ saligna$talhao) #boxplot de dap por talhao
text(x=0.5,y=22,"a", cex=1.5) #adicionando identificacao do grafico

medias$Group.1 <- as.numeric(medias$Group.1) #transformando talhoes em numerico para plotar circulos
plot(medias, xlab="", ylab="",pch=16, ylim=c(5.5,23.0),xaxt="n") #plotando as medias
axis(1,at=1:6, labels=c(16,17,18,22,23,32)) #arrumando eixo x
points (x=medias[,1],y=medias[,2]+desvpad[,2], pch="-",cex=2) #plotando os limites superiores
points (x=medias[,1],y=medias[,2]-desvpad[,2], pch="-",cex=2) #plotando os limites inferiores
segments(x=medias[,1], y0=medias[,2]-desvpad[,2], x1=medias[,1], y1=medias[,2]+desvpad[,2]) #plotando os segmentos
text(x=1,y=22,"b",cex=1.5) #adicionando identificacao do grafico

### 5.3 ###
dados <- read.table("exercicio3.csv", h=T, sep=",") #lendo dados como data frame
str(dados) #entendendo a estrutura dos dados
head(dados) #observando dados
tail(dados) #observando dados

# observa-se que :
#x1: eixo horizontal do grafico de xy - log(Patch size)(ha) -variavel numerica
#y1 e o eixo vertical do grafico xy - euclidean distance - variavel numerica
#x2 e o eixo vertical do boxplot - euclidean distance - variavel numerica
#y2 e eixo horizontal do boxplot - fator de 6 niveis - variavel categorica
#y1 e x2 diferem pela presenca do "control" nos dados (x2,y2), constam como NA nos dados (x1,y1)
        
jpeg(file="exercicio3.jpeg", width=1009, height=554) #abrindo dispositivo para salvar a imagem em jpeg nos tamanhos determinados
        
#especificacoes de parametros
par(mar=c(5,5,1,0)) #arrumando a margem dos graficos
par(family="serif") #definindo a letra
par(mfrow=c(1,2)) #layout de 2 graficos em 1 linha
par(bty="l") #especificacao de bordas
par(cex.axis=1.7) #tamanho dos ticks dos eixos
par(tcl=0.5) #tick marks dos eixos para dentro do grafico

#grafico xy
plot(dados$y1 ~dados$x1, pch=17, xlim=c(0.5,2.5), ylim=c(0,3), xlab="Log(Patch size)(ha)", ylab="Euclidean distance", cex=2, cex.lab=2) #plotando pontos x1 X y1 com as especificacoes
abline(lm(dados$y1 ~ dados$x1,), lwd=4) #construindo a linha do modelo mais grossa
text(x=2.5, y=3.0, "a", cex=3) #incluindo texto de identificacao do grafico ("a")

#grafico boxplot
dados$y2 <- factor(dados$y2) #transformando y2 em fatores de 6 niveus
boxplot(dados$x2 ~ dados$y2, outline=FALSE, ylim=c(0,3.0), xaxt="n") #construindo o boxplot sem outliers e nas especificacoes determinadas
axis(1, at=c(1:6),labels=c("Small", "Medium\n Edge", "Medium\n Interior", "Large\n Edge", "Large\n Interior", "Control"), cex.axis=1.2, mgp =c(3,2,0)) #incluindo eixo X correto com nome dos fatores em tamanho e distancia correta do eixo
text(x=6,y=3.0, "b", cex=3) #incluindo texto de identificacao do grafico ("b")
text(x=c(1:5), y=rep(3,5),c("*","*","**","*","***"), cex=2.2) #incluindo identificacao de significancia de diferença com controle

dev.off() #fechando o dispositivo, salvando a imagem no dietorio
